jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | # |
| 3 | # Copyright (C) 2007 The Android Open Source Project |
| 4 | # |
| 5 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 6 | # you may not use this file except in compliance with the License. |
| 7 | # You may obtain a copy of the License at |
| 8 | # |
| 9 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 10 | # |
| 11 | # Unless required by applicable law or agreed to in writing, software |
| 12 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 13 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 14 | # See the License for the specific language governing permissions and |
| 15 | # limitations under the License. |
| 16 | |
| 17 | # Set up prog to be the path of this script, including following symlinks, |
| 18 | # and set up progdir to be the fully-qualified pathname of its directory. |
| 19 | prog="$0" |
Andreas Gampe | deb48a0 | 2014-10-22 00:44:35 -0700 | [diff] [blame] | 20 | args="$@" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 21 | while [ -h "${prog}" ]; do |
| 22 | newProg=`/bin/ls -ld "${prog}"` |
| 23 | newProg=`expr "${newProg}" : ".* -> \(.*\)$"` |
| 24 | if expr "x${newProg}" : 'x/' >/dev/null; then |
| 25 | prog="${newProg}" |
| 26 | else |
| 27 | progdir=`dirname "${prog}"` |
| 28 | prog="${progdir}/${newProg}" |
| 29 | fi |
| 30 | done |
| 31 | oldwd=`pwd` |
| 32 | progdir=`dirname "${prog}"` |
| 33 | cd "${progdir}" |
| 34 | progdir=`pwd` |
| 35 | prog="${progdir}"/`basename "${prog}"` |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 36 | test_dir="test-$$" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 37 | if [ -z "$TMPDIR" ]; then |
| 38 | tmp_dir="/tmp/$USER/${test_dir}" |
| 39 | else |
Andreas Gampe | 34a8a0f | 2016-07-20 21:09:29 -0700 | [diff] [blame] | 40 | tmp_dir="${TMPDIR}/${test_dir}" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 41 | fi |
David Brazdil | 2c27f2c | 2015-05-12 18:06:38 +0100 | [diff] [blame] | 42 | checker="${progdir}/../tools/checker/checker.py" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 43 | export JAVA="java" |
Alex Light | ea1e770 | 2016-07-11 13:39:55 -0700 | [diff] [blame] | 44 | export JAVAC="javac -g -Xlint:-options" |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 45 | export RUN="${progdir}/etc/run-test-jar" |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 46 | export DEX_LOCATION=/data/run-test/${test_dir} |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 47 | export NEED_DEX="true" |
Colin Cross | e0ef0a8 | 2017-07-27 21:29:18 +0000 | [diff] [blame] | 48 | export USE_JACK="false" |
Igor Murashkin | 2a33775 | 2017-06-16 14:34:40 +0000 | [diff] [blame] | 49 | export USE_DESUGAR="true" |
Ben Gruver | 14fc9db | 2017-04-28 15:30:49 -0700 | [diff] [blame] | 50 | export SMALI_ARGS="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 51 | |
Tsu Chiang Chuang | 4407e61 | 2012-07-19 16:13:43 -0700 | [diff] [blame] | 52 | # If dx was not set by the environment variable, assume it is in the path. |
| 53 | if [ -z "$DX" ]; then |
| 54 | export DX="dx" |
| 55 | fi |
| 56 | |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 57 | # If jasmin was not set by the environment variable, assume it is in the path. |
| 58 | if [ -z "$JASMIN" ]; then |
| 59 | export JASMIN="jasmin" |
| 60 | fi |
| 61 | |
Andreas Gampe | 8fda9f2 | 2014-10-03 16:15:37 -0700 | [diff] [blame] | 62 | # If smali was not set by the environment variable, assume it is in the path. |
| 63 | if [ -z "$SMALI" ]; then |
| 64 | export SMALI="smali" |
| 65 | fi |
| 66 | |
| 67 | # If dexmerger was not set by the environment variable, assume it is in the path. |
| 68 | if [ -z "$DXMERGER" ]; then |
| 69 | export DXMERGER="dexmerger" |
| 70 | fi |
| 71 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 72 | # If jack was not set by the environment variable, assume it is in the path. |
| 73 | if [ -z "$JACK" ]; then |
| 74 | export JACK="jack" |
| 75 | fi |
| 76 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 77 | # ANDROID_BUILD_TOP is not set in a build environment. |
| 78 | if [ -z "$ANDROID_BUILD_TOP" ]; then |
| 79 | export ANDROID_BUILD_TOP=$oldwd |
| 80 | fi |
| 81 | |
Andreas Gampe | f47fb2f | 2016-06-24 22:30:29 -0700 | [diff] [blame] | 82 | # ANDROID_HOST_OUT is not set in a build environment. |
| 83 | if [ -z "$ANDROID_HOST_OUT" ]; then |
Dan Willemsen | f325e01 | 2017-03-03 12:35:30 -0800 | [diff] [blame] | 84 | export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out}/host/linux-x86 |
Andreas Gampe | f47fb2f | 2016-06-24 22:30:29 -0700 | [diff] [blame] | 85 | fi |
| 86 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 87 | # If JACK_CLASSPATH is not set, assume it only contains core-libart. |
| 88 | if [ -z "$JACK_CLASSPATH" ]; then |
Andreas Gampe | f47fb2f | 2016-06-24 22:30:29 -0700 | [diff] [blame] | 89 | export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 90 | fi |
| 91 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 92 | export JACK="$JACK -g -cp $JACK_CLASSPATH" |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 93 | |
Igor Murashkin | e518193 | 2017-06-15 16:03:50 -0700 | [diff] [blame] | 94 | # Allow changing DESUGAR script to something else, or to disable it with DESUGAR=false. |
Igor Murashkin | d323277 | 2017-06-22 14:54:13 -0700 | [diff] [blame] | 95 | if [ -z "$DESUGAR" ]; then |
Igor Murashkin | e518193 | 2017-06-15 16:03:50 -0700 | [diff] [blame] | 96 | export DESUGAR="$ANDROID_BUILD_TOP/art/tools/desugar.sh" |
| 97 | fi |
| 98 | |
Igor Murashkin | 271a0f8 | 2017-02-14 21:14:17 +0000 | [diff] [blame] | 99 | # Zipalign is not on the PATH in some configs, auto-detect it. |
| 100 | if [ -z "$ZIPALIGN" ]; then |
| 101 | if which zipalign >/dev/null; then |
| 102 | ZIPALIGN="zipalign"; |
| 103 | else |
| 104 | # TODO: Add a dependency for zipalign in Android.run-test.mk |
| 105 | # once it doesn't depend on libandroidfw (b/35246701) |
| 106 | case "$OSTYPE" in |
| 107 | darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;; |
| 108 | linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;; |
| 109 | *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;; |
| 110 | esac |
| 111 | fi |
| 112 | fi |
| 113 | export ZIPALIGN |
| 114 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 115 | info="info.txt" |
| 116 | build="build" |
| 117 | run="run" |
| 118 | expected="expected.txt" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 119 | check_cmd="check" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 120 | output="output.txt" |
| 121 | build_output="build-output.txt" |
David Brazdil | 24128c6 | 2015-05-21 12:06:13 +0100 | [diff] [blame] | 122 | cfg_output="graph.cfg" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 123 | strace_output="strace-output.txt" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 124 | lib="libartd.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 125 | testlib="arttestd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 126 | run_args="--quiet" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 127 | build_args="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 128 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 129 | quiet="no" |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 130 | debuggable="no" |
Alex Light | 9d72253 | 2014-07-22 18:07:12 -0700 | [diff] [blame] | 131 | prebuild_mode="yes" |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 132 | target_mode="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 133 | dev_mode="no" |
| 134 | update_mode="no" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 135 | debug_mode="no" |
Nicolas Geoffray | 94e25db | 2017-01-27 14:54:28 +0000 | [diff] [blame] | 136 | relocate="no" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 137 | runtime="art" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 138 | usage="no" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 139 | build_only="no" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 140 | suffix64="" |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 141 | trace="false" |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 142 | trace_stream="false" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 143 | basic_verify="false" |
| 144 | gc_verify="false" |
| 145 | gc_stress="false" |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 146 | jvmti_trace_stress="false" |
Alex Light | 43e935d | 2017-06-19 15:40:40 -0700 | [diff] [blame] | 147 | jvmti_field_stress="false" |
Alex Light | c38c369 | 2017-06-27 15:45:14 -0700 | [diff] [blame] | 148 | jvmti_step_stress="false" |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 149 | jvmti_redefine_stress="false" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 150 | strace="false" |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 151 | always_clean="no" |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 152 | never_clean="no" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 153 | have_dex2oat="yes" |
| 154 | have_patchoat="yes" |
| 155 | have_image="yes" |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 156 | multi_image_suffix="" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 157 | android_root="/system" |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 158 | bisection_search="no" |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 159 | suspend_timeout="500000" |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 160 | # By default we will use optimizing. |
| 161 | image_args="" |
Nicolas Geoffray | b76bc78 | 2016-09-14 12:33:34 +0000 | [diff] [blame] | 162 | image_suffix="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 163 | |
| 164 | while true; do |
| 165 | if [ "x$1" = "x--host" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 166 | target_mode="no" |
TDYa127 | b92bcab | 2012-04-08 00:09:51 -0700 | [diff] [blame] | 167 | DEX_LOCATION=$tmp_dir |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 168 | run_args="${run_args} --host" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 169 | shift |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 170 | elif [ "x$1" = "x--quiet" ]; then |
| 171 | quiet="yes" |
| 172 | shift |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 173 | elif [ "x$1" = "x--use-java-home" ]; then |
| 174 | if [ -n "${JAVA_HOME}" ]; then |
| 175 | export JAVA="${JAVA_HOME}/bin/java" |
| 176 | export JAVAC="${JAVA_HOME}/bin/javac -g" |
| 177 | else |
| 178 | echo "Passed --use-java-home without JAVA_HOME variable set!" |
| 179 | usage="yes" |
| 180 | fi |
| 181 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 182 | elif [ "x$1" = "x--jvm" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 183 | target_mode="no" |
Alex Light | 2c7aaeb | 2017-01-27 14:08:17 -0800 | [diff] [blame] | 184 | DEX_LOCATION="$tmp_dir" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 185 | runtime="jvm" |
Alex Light | bc90d0f | 2016-05-09 16:21:09 -0700 | [diff] [blame] | 186 | image_args="" |
Brian Carlstrom | 01afdba | 2014-10-03 10:28:47 -0700 | [diff] [blame] | 187 | prebuild_mode="no" |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 188 | NEED_DEX="false" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 189 | USE_JACK="false" |
Nicolas Geoffray | 288a4a2 | 2014-10-07 11:02:40 +0100 | [diff] [blame] | 190 | run_args="${run_args} --jvm" |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 191 | build_args="${build_args} --jvm" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 192 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 193 | elif [ "x$1" = "x-O" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 194 | lib="libart.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 195 | testlib="arttest" |
Alex Light | faf90b6 | 2016-08-12 14:43:48 -0700 | [diff] [blame] | 196 | run_args="${run_args} -O" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 197 | shift |
| 198 | elif [ "x$1" = "x--dalvik" ]; then |
| 199 | lib="libdvm.so" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 200 | runtime="dalvik" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 201 | shift |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 202 | elif [ "x$1" = "x--no-dex2oat" ]; then |
| 203 | have_dex2oat="no" |
| 204 | shift |
| 205 | elif [ "x$1" = "x--no-patchoat" ]; then |
| 206 | have_patchoat="no" |
| 207 | shift |
| 208 | elif [ "x$1" = "x--no-image" ]; then |
| 209 | have_image="no" |
| 210 | shift |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 211 | elif [ "x$1" = "x--multi-image" ]; then |
| 212 | multi_image_suffix="-multi" |
| 213 | shift |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 214 | elif [ "x$1" = "x--pic-test" ]; then |
| 215 | run_args="${run_args} --pic-test" |
| 216 | shift |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 217 | elif [ "x$1" = "x--relocate" ]; then |
| 218 | relocate="yes" |
| 219 | shift |
| 220 | elif [ "x$1" = "x--no-relocate" ]; then |
| 221 | relocate="no" |
| 222 | shift |
| 223 | elif [ "x$1" = "x--prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 224 | run_args="${run_args} --prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 225 | prebuild_mode="yes" |
| 226 | shift; |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 227 | elif [ "x$1" = "x--strip-dex" ]; then |
| 228 | run_args="${run_args} --strip-dex" |
| 229 | shift; |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 230 | elif [ "x$1" = "x--debuggable" ]; then |
| 231 | run_args="${run_args} -Xcompiler-option --debuggable" |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 232 | debuggable="yes" |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 233 | shift; |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 234 | elif [ "x$1" = "x--no-prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 235 | run_args="${run_args} --no-prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 236 | prebuild_mode="no" |
| 237 | shift; |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 238 | elif [ "x$1" = "x--gcverify" ]; then |
| 239 | basic_verify="true" |
| 240 | gc_verify="true" |
| 241 | shift |
| 242 | elif [ "x$1" = "x--gcstress" ]; then |
| 243 | basic_verify="true" |
| 244 | gc_stress="true" |
| 245 | shift |
Alex Light | c38c369 | 2017-06-27 15:45:14 -0700 | [diff] [blame] | 246 | elif [ "x$1" = "x--jvmti-step-stress" ]; then |
| 247 | jvmti_step_stress="true" |
| 248 | shift |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 249 | elif [ "x$1" = "x--jvmti-redefine-stress" ]; then |
| 250 | jvmti_redefine_stress="true" |
| 251 | shift |
Alex Light | 43e935d | 2017-06-19 15:40:40 -0700 | [diff] [blame] | 252 | elif [ "x$1" = "x--jvmti-field-stress" ]; then |
| 253 | jvmti_field_stress="true" |
| 254 | shift |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 255 | elif [ "x$1" = "x--jvmti-trace-stress" ]; then |
| 256 | jvmti_trace_stress="true" |
Alex Light | 8f2c6d4 | 2017-04-10 16:27:35 -0700 | [diff] [blame] | 257 | shift |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 258 | elif [ "x$1" = "x--suspend-timeout" ]; then |
| 259 | shift |
| 260 | suspend_timeout="$1" |
| 261 | shift |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 262 | elif [ "x$1" = "x--image" ]; then |
| 263 | shift |
| 264 | image="$1" |
| 265 | run_args="${run_args} --image $image" |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 266 | shift |
Nicolas Geoffray | 92cf83e | 2014-03-18 17:59:20 +0000 | [diff] [blame] | 267 | elif [ "x$1" = "x-Xcompiler-option" ]; then |
| 268 | shift |
| 269 | option="$1" |
| 270 | run_args="${run_args} -Xcompiler-option $option" |
| 271 | shift |
Orion Hodson | e1fb77f | 2017-02-27 13:57:18 +0000 | [diff] [blame] | 272 | elif [ "x$1" = "x--build-option" ]; then |
| 273 | shift |
| 274 | option="$1" |
| 275 | build_args="${build_args} $option" |
| 276 | shift |
Mathieu Chartier | 769a5ad | 2014-05-18 15:30:10 -0700 | [diff] [blame] | 277 | elif [ "x$1" = "x--runtime-option" ]; then |
| 278 | shift |
| 279 | option="$1" |
| 280 | run_args="${run_args} --runtime-option $option" |
| 281 | shift |
Mathieu Chartier | c0a8a80 | 2014-10-17 15:58:01 -0700 | [diff] [blame] | 282 | elif [ "x$1" = "x--gdb-arg" ]; then |
| 283 | shift |
| 284 | gdb_arg="$1" |
| 285 | run_args="${run_args} --gdb-arg $gdb_arg" |
| 286 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 287 | elif [ "x$1" = "x--debug" ]; then |
| 288 | run_args="${run_args} --debug" |
| 289 | shift |
| 290 | elif [ "x$1" = "x--gdb" ]; then |
| 291 | run_args="${run_args} --gdb" |
| 292 | dev_mode="yes" |
| 293 | shift |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 294 | elif [ "x$1" = "x--strace" ]; then |
| 295 | strace="yes" |
Mathieu Chartier | 2576be2 | 2016-05-24 10:24:53 -0700 | [diff] [blame] | 296 | run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 297 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 298 | elif [ "x$1" = "x--zygote" ]; then |
| 299 | run_args="${run_args} --zygote" |
| 300 | shift |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 301 | elif [ "x$1" = "x--interpreter" ]; then |
Nicolas Geoffray | 4650c93 | 2016-05-10 09:13:13 +0000 | [diff] [blame] | 302 | run_args="${run_args} --interpreter" |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 303 | image_suffix="-interpreter" |
| 304 | shift |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 305 | elif [ "x$1" = "x--jit" ]; then |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 306 | image_args="--jit" |
Nicolas Geoffray | b76bc78 | 2016-09-14 12:33:34 +0000 | [diff] [blame] | 307 | image_suffix="-interpreter" |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 308 | shift |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 309 | elif [ "x$1" = "x--optimizing" ]; then |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 310 | image_args="-Xcompiler-option --compiler-backend=Optimizing" |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 311 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 312 | elif [ "x$1" = "x--no-verify" ]; then |
Richard Uhler | f4b3487 | 2016-04-13 11:03:46 -0700 | [diff] [blame] | 313 | run_args="${run_args} --no-verify" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 314 | shift |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 315 | elif [ "x$1" = "x--verify-soft-fail" ]; then |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 316 | image_args="--verify-soft-fail" |
Andreas Gampe | 825570c | 2015-07-26 10:26:03 -0700 | [diff] [blame] | 317 | image_suffix="-interp-ac" |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 318 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 319 | elif [ "x$1" = "x--no-optimize" ]; then |
| 320 | run_args="${run_args} --no-optimize" |
| 321 | shift |
| 322 | elif [ "x$1" = "x--no-precise" ]; then |
| 323 | run_args="${run_args} --no-precise" |
| 324 | shift |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 325 | elif [ "x$1" = "x--invoke-with" ]; then |
| 326 | shift |
| 327 | what="$1" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 328 | if [ "x$what" = "x" ]; then |
| 329 | echo "$0 missing argument to --invoke-with" 1>&2 |
| 330 | usage="yes" |
| 331 | break |
| 332 | fi |
Ian Rogers | 0e03367 | 2013-04-19 10:22:46 -0700 | [diff] [blame] | 333 | run_args="${run_args} --invoke-with ${what}" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 334 | shift |
| 335 | elif [ "x$1" = "x--dev" ]; then |
| 336 | run_args="${run_args} --dev" |
| 337 | dev_mode="yes" |
| 338 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 339 | elif [ "x$1" = "x--build-only" ]; then |
| 340 | build_only="yes" |
| 341 | shift |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 342 | elif [ "x$1" = "x--build-with-javac-dx" ]; then |
| 343 | USE_JACK="false" |
| 344 | shift |
| 345 | elif [ "x$1" = "x--build-with-jack" ]; then |
| 346 | USE_JACK="true" |
| 347 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 348 | elif [ "x$1" = "x--output-path" ]; then |
| 349 | shift |
| 350 | tmp_dir=$1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 351 | if [ "x$tmp_dir" = "x" ]; then |
| 352 | echo "$0 missing argument to --output-path" 1>&2 |
| 353 | usage="yes" |
| 354 | break |
| 355 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 356 | shift |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 357 | elif [ "x$1" = "x--android-root" ]; then |
| 358 | shift |
| 359 | if [ "x$1" = "x" ]; then |
| 360 | echo "$0 missing argument to --android-root" 1>&2 |
| 361 | usage="yes" |
| 362 | break |
| 363 | fi |
| 364 | android_root="$1" |
| 365 | run_args="${run_args} --android-root $1" |
| 366 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 367 | elif [ "x$1" = "x--update" ]; then |
| 368 | update_mode="yes" |
| 369 | shift |
| 370 | elif [ "x$1" = "x--help" ]; then |
| 371 | usage="yes" |
| 372 | shift |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 373 | elif [ "x$1" = "x--64" ]; then |
| 374 | run_args="${run_args} --64" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 375 | suffix64="64" |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 376 | shift |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 377 | elif [ "x$1" = "x--trace" ]; then |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 378 | trace="true" |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 379 | shift |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 380 | elif [ "x$1" = "x--stream" ]; then |
| 381 | trace_stream="true" |
| 382 | shift |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 383 | elif [ "x$1" = "x--always-clean" ]; then |
| 384 | always_clean="yes" |
| 385 | shift |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 386 | elif [ "x$1" = "x--never-clean" ]; then |
| 387 | never_clean="yes" |
| 388 | shift |
Andreas Gampe | e21dc3d | 2014-12-08 16:59:43 -0800 | [diff] [blame] | 389 | elif [ "x$1" = "x--dex2oat-swap" ]; then |
| 390 | run_args="${run_args} --dex2oat-swap" |
| 391 | shift |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 392 | elif [ "x$1" = "x--instruction-set-features" ]; then |
| 393 | shift |
| 394 | run_args="${run_args} --instruction-set-features $1" |
| 395 | shift |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 396 | elif [ "x$1" = "x--bisection-search" ]; then |
| 397 | bisection_search="yes" |
| 398 | shift |
Nicolas Geoffray | b0bbe8e | 2016-11-19 10:42:37 +0000 | [diff] [blame] | 399 | elif [ "x$1" = "x--vdex" ]; then |
| 400 | run_args="${run_args} --vdex" |
| 401 | shift |
Nicolas Geoffray | 7498105 | 2017-01-16 17:54:09 +0000 | [diff] [blame] | 402 | elif [ "x$1" = "x--vdex-filter" ]; then |
| 403 | shift |
| 404 | filter=$1 |
| 405 | run_args="${run_args} --vdex-filter $filter" |
| 406 | shift |
Jeff Hao | 002b931 | 2017-03-27 16:23:08 -0700 | [diff] [blame] | 407 | elif [ "x$1" = "x--random-profile" ]; then |
| 408 | run_args="${run_args} --random-profile" |
| 409 | shift |
Shubham Ajmera | 981d99c | 2017-08-17 14:11:08 -0700 | [diff] [blame] | 410 | elif [ "x$1" = "x--dex2oat-jobs" ]; then |
| 411 | shift |
| 412 | run_args="${run_args} -Xcompiler-option -j$1" |
| 413 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 414 | elif expr "x$1" : "x--" >/dev/null 2>&1; then |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 415 | echo "unknown $0 option: $1" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 416 | usage="yes" |
| 417 | break |
| 418 | else |
| 419 | break |
| 420 | fi |
| 421 | done |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 422 | |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 423 | run_args="${run_args} ${image_args}" |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 424 | # Allocate file descriptor real_stderr and redirect it to the shell's error |
| 425 | # output (fd 2). |
| 426 | if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then |
| 427 | exec {real_stderr}>&2 |
| 428 | else |
| 429 | # In bash before version 4.1 we need to do a manual search for free file |
| 430 | # descriptors. |
| 431 | FD=3 |
| 432 | while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done |
| 433 | real_stderr=$FD |
| 434 | eval "exec ${real_stderr}>&2" |
| 435 | fi |
| 436 | if [ "$quiet" = "yes" ]; then |
| 437 | # Force the default standard output and error to go to /dev/null so we will |
| 438 | # not print them. |
| 439 | exec 1>/dev/null |
| 440 | exec 2>/dev/null |
| 441 | fi |
| 442 | |
| 443 | function err_echo() { |
| 444 | echo "$@" 1>&${real_stderr} |
| 445 | } |
| 446 | |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 447 | # tmp_dir may be relative, resolve. |
| 448 | # |
| 449 | # Cannot use realpath, as it does not exist on Mac. |
| 450 | # Cannot us a simple "cd", as the path might not be created yet. |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 451 | # Cannot use readlink -m, as it does not exist on Mac. |
| 452 | # Fallback to nuclear option: |
Andreas Gampe | 907b699 | 2014-08-18 22:26:49 -0700 | [diff] [blame] | 453 | noncanonical_tmp_dir=$tmp_dir |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 454 | tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`" |
Dmitry Petrochenko | 81c56e7 | 2014-03-05 15:05:46 +0700 | [diff] [blame] | 455 | mkdir -p $tmp_dir |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 456 | |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 457 | # Add thread suspend timeout flag |
Narayan Kamath | f86c393 | 2017-01-24 17:40:47 +0000 | [diff] [blame] | 458 | if [ ! "$runtime" = "jvm" ]; then |
| 459 | run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout" |
| 460 | fi |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 461 | |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 462 | if [ "$basic_verify" = "true" ]; then |
Hiroshi Yamauchi | 312baf1 | 2015-01-12 12:11:05 -0800 | [diff] [blame] | 463 | # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests. |
| 464 | run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 465 | fi |
| 466 | if [ "$gc_verify" = "true" ]; then |
| 467 | run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc" |
| 468 | fi |
| 469 | if [ "$gc_stress" = "true" ]; then |
Mathieu Chartier | d9eb284 | 2016-08-12 16:11:24 -0700 | [diff] [blame] | 470 | run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 471 | fi |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 472 | if [ "$jvmti_redefine_stress" = "true" ]; then |
| 473 | run_args="${run_args} --no-app-image --jvmti-redefine-stress" |
| 474 | fi |
Alex Light | c38c369 | 2017-06-27 15:45:14 -0700 | [diff] [blame] | 475 | if [ "$jvmti_step_stress" = "true" ]; then |
| 476 | run_args="${run_args} --no-app-image --jvmti-step-stress" |
| 477 | fi |
Alex Light | 43e935d | 2017-06-19 15:40:40 -0700 | [diff] [blame] | 478 | if [ "$jvmti_field_stress" = "true" ]; then |
| 479 | run_args="${run_args} --no-app-image --jvmti-field-stress" |
| 480 | fi |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 481 | if [ "$jvmti_trace_stress" = "true" ]; then |
| 482 | run_args="${run_args} --no-app-image --jvmti-trace-stress" |
Alex Light | 8f2c6d4 | 2017-04-10 16:27:35 -0700 | [diff] [blame] | 483 | fi |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 484 | if [ "$trace" = "true" ]; then |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 485 | run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000" |
| 486 | if [ "$trace_stream" = "true" ]; then |
| 487 | # Streaming mode uses the file size as the buffer size. So output gets really large. Drop |
| 488 | # the ability to analyze the file and just write to /dev/null. |
| 489 | run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null" |
| 490 | # Enable streaming mode. |
| 491 | run_args="${run_args} --runtime-option -Xmethod-trace-stream" |
| 492 | else |
| 493 | run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin" |
| 494 | fi |
| 495 | elif [ "$trace_stream" = "true" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 496 | err_echo "Cannot use --stream without --trace." |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 497 | exit 1 |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 498 | fi |
| 499 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 500 | # Most interesting target architecture variables are Makefile variables, not environment variables. |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 501 | # Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name. |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 502 | function guess_target_arch_name() { |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 503 | grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'` |
Andreas Gampe | 1a5c406 | 2015-01-15 12:10:47 -0800 | [diff] [blame] | 504 | grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'` |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 505 | if [ "x${suffix64}" = "x64" ]; then |
| 506 | target_arch_name=${grep64bit} |
| 507 | else |
| 508 | target_arch_name=${grep32bit} |
| 509 | fi |
| 510 | } |
| 511 | |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 512 | function guess_host_arch_name() { |
| 513 | if [ "x${suffix64}" = "x64" ]; then |
| 514 | host_arch_name="x86_64" |
| 515 | else |
| 516 | host_arch_name="x86" |
| 517 | fi |
| 518 | } |
| 519 | |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 520 | if [ "$target_mode" = "no" ]; then |
| 521 | if [ "$runtime" = "jvm" ]; then |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 522 | if [ "$prebuild_mode" = "yes" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 523 | err_echo "--prebuild with --jvm is unsupported" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 524 | exit 1; |
| 525 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 526 | fi |
| 527 | fi |
| 528 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 529 | if [ "$have_patchoat" = "no" ]; then |
| 530 | run_args="${run_args} --no-patchoat" |
| 531 | fi |
| 532 | |
| 533 | if [ "$have_dex2oat" = "no" ]; then |
| 534 | run_args="${run_args} --no-dex2oat" |
| 535 | fi |
| 536 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 537 | if [ ! "$runtime" = "jvm" ]; then |
| 538 | run_args="${run_args} --lib $lib" |
| 539 | fi |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 540 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 541 | if [ "$runtime" = "dalvik" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 542 | if [ "$target_mode" = "no" ]; then |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 543 | framework="${ANDROID_PRODUCT_OUT}/system/framework" |
Andreas Gampe | 50be66f | 2015-12-28 14:31:06 -0800 | [diff] [blame] | 544 | bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar" |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 545 | run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 546 | else |
| 547 | true # defaults to using target BOOTCLASSPATH |
| 548 | fi |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 549 | elif [ "$runtime" = "art" ]; then |
| 550 | if [ "$target_mode" = "no" ]; then |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 551 | guess_host_arch_name |
Richard Uhler | bb00f81 | 2017-02-16 14:21:10 +0000 | [diff] [blame] | 552 | run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${multi_image_suffix}.art" |
Colin Cross | afd3c9e | 2016-09-16 13:47:21 -0700 | [diff] [blame] | 553 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 554 | else |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 555 | guess_target_arch_name |
Dimitry Ivanov | 49c2c92 | 2017-02-14 11:06:14 -0800 | [diff] [blame] | 556 | run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}" |
Richard Uhler | bb00f81 | 2017-02-16 14:21:10 +0000 | [diff] [blame] | 557 | run_args="${run_args} --boot /data/art-test/core${image_suffix}${multi_image_suffix}.art" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 558 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 559 | if [ "$relocate" = "yes" ]; then |
| 560 | run_args="${run_args} --relocate" |
| 561 | else |
| 562 | run_args="${run_args} --no-relocate" |
| 563 | fi |
Andreas Gampe | 3f1dc56 | 2015-05-18 15:52:22 -0700 | [diff] [blame] | 564 | elif [ "$runtime" = "jvm" ]; then |
| 565 | # TODO: Detect whether the host is 32-bit or 64-bit. |
Alex Light | fba89fe | 2017-01-12 16:11:02 -0800 | [diff] [blame] | 566 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 567 | fi |
| 568 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 569 | if [ "$have_image" = "no" ]; then |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 570 | if [ "$runtime" != "art" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 571 | err_echo "--no-image is only supported on the art runtime" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 572 | exit 1 |
| 573 | fi |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 574 | run_args="${run_args} --no-image" |
| 575 | fi |
| 576 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 577 | if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 578 | err_echo "--dev and --update are mutually exclusive" |
| 579 | usage="yes" |
| 580 | fi |
| 581 | |
| 582 | if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then |
| 583 | err_echo "--dev and --quiet are mutually exclusive" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 584 | usage="yes" |
| 585 | fi |
| 586 | |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 587 | if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then |
| 588 | err_echo "--bisection-search and --prebuild are mutually exclusive" |
| 589 | usage="yes" |
| 590 | fi |
| 591 | |
| 592 | if [ "$bisection_search" = "yes" -a "$have_dex2oat" = "no" ]; then |
| 593 | err_echo "--bisection-search and --no-dex2oat are mutually exclusive" |
| 594 | usage="yes" |
| 595 | fi |
| 596 | |
| 597 | if [ "$bisection_search" = "yes" -a "$have_patchoat" = "no" ]; then |
| 598 | err_echo "--bisection-search and --no-patchoat are mutually exclusive" |
| 599 | usage="yes" |
| 600 | fi |
| 601 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 602 | if [ "$usage" = "no" ]; then |
| 603 | if [ "x$1" = "x" -o "x$1" = "x-" ]; then |
| 604 | test_dir=`basename "$oldwd"` |
| 605 | else |
| 606 | test_dir="$1" |
| 607 | fi |
| 608 | |
| 609 | if [ '!' -d "$test_dir" ]; then |
| 610 | td2=`echo ${test_dir}-*` |
| 611 | if [ '!' -d "$td2" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 612 | err_echo "${test_dir}: no such test directory" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 613 | usage="yes" |
| 614 | fi |
| 615 | test_dir="$td2" |
| 616 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 617 | # Shift to get rid of the test name argument. The rest of the arguments |
| 618 | # will get passed to the test run. |
| 619 | shift |
| 620 | fi |
| 621 | |
Søren Gjesse | 620d0a5 | 2016-09-19 11:12:51 +0200 | [diff] [blame] | 622 | # For building with javac and dx always use Java 7. The dx compiler |
| 623 | # only support byte codes from Java 7 or earlier (class file major |
| 624 | # version 51 or lower). |
| 625 | if [ "$USE_JACK" != "true" ] && [ "$NEED_DEX" = "true" ]; then |
| 626 | export JAVAC="${JAVAC} -source 1.7 -target 1.7" |
| 627 | fi |
| 628 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 629 | if [ "$usage" = "yes" ]; then |
| 630 | prog=`basename $prog` |
| 631 | ( |
| 632 | echo "usage:" |
| 633 | echo " $prog --help Print this message." |
| 634 | echo " $prog [options] [test-name] Run test normally." |
| 635 | echo " $prog --dev [options] [test-name] Development mode" \ |
| 636 | "(dumps to stdout)." |
| 637 | echo " $prog --update [options] [test-name] Update mode" \ |
| 638 | "(replaces expected.txt)." |
| 639 | echo ' Omitting the test name or specifying "-" will use the' \ |
| 640 | "current directory." |
| 641 | echo " Runtime Options:" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 642 | echo " -O Run non-debug rather than debug build (off by default)." |
| 643 | echo " -Xcompiler-option Pass an option to the compiler." |
Orion Hodson | e1fb77f | 2017-02-27 13:57:18 +0000 | [diff] [blame] | 644 | echo " --build-option Pass an option to the build script." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 645 | echo " --runtime-option Pass an option to the runtime." |
| 646 | echo " --debug Wait for a debugger to attach." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 647 | echo " --debuggable Whether to compile Java code for a debugger." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 648 | echo " --gdb Run under gdb; incompatible with some tests." |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 649 | echo " --gdb-arg Pass an option to gdb." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 650 | echo " --build-only Build test files only (off by default)." |
Søren Gjesse | 620d0a5 | 2016-09-19 11:12:51 +0200 | [diff] [blame] | 651 | echo " --build-with-javac-dx Build test files with javac and dx (off by default)." |
| 652 | echo " --build-with-jack Build test files with jack and jill (on by default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 653 | echo " --interpreter Enable interpreter only mode (off by default)." |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 654 | echo " --jit Enable jit (off by default)." |
Nicolas Geoffray | 0e07125 | 2015-03-21 13:43:15 +0000 | [diff] [blame] | 655 | echo " --optimizing Enable optimizing compiler (default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 656 | echo " --no-verify Turn off verification (on by default)." |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 657 | echo " --verify-soft-fail Force soft fail verification (off by default)." |
| 658 | echo " Verification is enabled if neither --no-verify" |
| 659 | echo " nor --verify-soft-fail is specified." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 660 | echo " --no-optimize Turn off optimization (on by default)." |
| 661 | echo " --no-precise Turn off precise GC (on by default)." |
| 662 | echo " --zygote Spawn the process from the Zygote." \ |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 663 | "If used, then the" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 664 | echo " other runtime options are ignored." |
| 665 | echo " --no-dex2oat Run as though dex2oat was failing." |
| 666 | echo " --no-patchoat Run as though patchoat was failing." |
| 667 | echo " --prebuild Run dex2oat on the files before starting test. (default)" |
| 668 | echo " --no-prebuild Do not run dex2oat on the files before starting" |
| 669 | echo " the test." |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 670 | echo " --strip-dex Strip the dex files before starting test." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 671 | echo " --relocate Force the use of relocating in the test, making" |
| 672 | echo " the image and oat files be relocated to a random" |
Nicolas Geoffray | 94e25db | 2017-01-27 14:54:28 +0000 | [diff] [blame] | 673 | echo " address before running." |
| 674 | echo " --no-relocate Force the use of no relocating in the test. (default)" |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 675 | echo " --image Run the test using a precompiled boot image. (default)" |
| 676 | echo " --no-image Run the test without a precompiled boot image." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 677 | echo " --host Use the host-mode virtual machine." |
| 678 | echo " --invoke-with Pass --invoke-with option to runtime." |
| 679 | echo " --dalvik Use Dalvik (off by default)." |
| 680 | echo " --jvm Use a host-local RI virtual machine." |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 681 | echo " --use-java-home Use the JAVA_HOME environment variable" |
| 682 | echo " to find the java compiler and runtime" |
| 683 | echo " (if applicable) to run the test with." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 684 | echo " --output-path [path] Location where to store the build" \ |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 685 | "files." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 686 | echo " --64 Run the test in 64-bit mode" |
| 687 | echo " --trace Run with method tracing" |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 688 | echo " --strace Run with syscall tracing from strace." |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 689 | echo " --stream Run method tracing in streaming mode (requires --trace)" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 690 | echo " --gcstress Run with gc stress testing" |
| 691 | echo " --gcverify Run with gc verification" |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 692 | echo " --jvmti-trace-stress Run with jvmti method tracing stress testing" |
Alex Light | c38c369 | 2017-06-27 15:45:14 -0700 | [diff] [blame] | 693 | echo " --jvmti-step-stress Run with jvmti single step stress testing" |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 694 | echo " --jvmti-redefine-stress" |
| 695 | echo " Run with jvmti method redefinition stress testing" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 696 | echo " --always-clean Delete the test files even if the test fails." |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 697 | echo " --never-clean Keep the test files even if the test succeeds." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 698 | echo " --android-root [path] The path on target for the android root. (/system by default)." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 699 | echo " --dex2oat-swap Use a dex2oat swap file." |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 700 | echo " --instruction-set-features [string]" |
| 701 | echo " Set instruction-set-features for compilation." |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 702 | echo " --multi-image Use a set of images compiled with dex2oat multi-image for" |
| 703 | echo " the boot class path." |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 704 | echo " --pic-test Compile the test code position independent." |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 705 | echo " --quiet Don't print anything except failure messages" |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 706 | echo " --bisection-search Perform bisection bug search." |
Nicolas Geoffray | b0bbe8e | 2016-11-19 10:42:37 +0000 | [diff] [blame] | 707 | echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild." |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 708 | echo " --suspend-timeout Change thread suspend timeout ms (default 500000)." |
Shubham Ajmera | 981d99c | 2017-08-17 14:11:08 -0700 | [diff] [blame] | 709 | echo " --dex2oat-jobs Number of dex2oat jobs." |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 710 | ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set. |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 711 | exit 1 |
| 712 | fi |
| 713 | |
| 714 | cd "$test_dir" |
| 715 | test_dir=`pwd` |
| 716 | |
| 717 | td_info="${test_dir}/${info}" |
| 718 | td_expected="${test_dir}/${expected}" |
| 719 | |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 720 | if [ ! -r $td_info ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 721 | err_echo "${test_dir}: missing file $td_info" |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 722 | exit 1 |
| 723 | fi |
| 724 | |
| 725 | if [ ! -r $td_expected ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 726 | err_echo "${test_dir}: missing file $td_expected" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 727 | exit 1 |
| 728 | fi |
| 729 | |
| 730 | # copy the test to a temp dir and run it |
| 731 | |
Elliott Hughes | 510c878 | 2011-10-06 10:57:34 -0700 | [diff] [blame] | 732 | echo "${test_dir}: building..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 733 | |
| 734 | rm -rf "$tmp_dir" |
| 735 | cp -Rp "$test_dir" "$tmp_dir" |
| 736 | cd "$tmp_dir" |
| 737 | |
| 738 | if [ '!' -r "$build" ]; then |
| 739 | cp "${progdir}/etc/default-build" build |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 740 | else |
| 741 | cp "${progdir}/etc/default-build" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 742 | fi |
| 743 | |
| 744 | if [ '!' -r "$run" ]; then |
| 745 | cp "${progdir}/etc/default-run" run |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 746 | else |
| 747 | cp "${progdir}/etc/default-run" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 748 | fi |
| 749 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 750 | if [ '!' -r "$check_cmd" ]; then |
| 751 | cp "${progdir}/etc/default-check" check |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 752 | else |
| 753 | cp "${progdir}/etc/default-check" . |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 754 | fi |
| 755 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 756 | chmod 755 "$build" |
| 757 | chmod 755 "$run" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 758 | chmod 755 "$check_cmd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 759 | |
Elliott Hughes | 8cbc8bc | 2011-10-04 11:19:45 -0700 | [diff] [blame] | 760 | export TEST_NAME=`basename ${test_dir}` |
| 761 | |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 762 | # Tests named '<number>-checker-*' will also have their CFGs verified with |
| 763 | # Checker when compiled with Optimizing on host. |
| 764 | if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then |
Igor Murashkin | 2c7cebd | 2017-06-26 14:10:02 -0700 | [diff] [blame] | 765 | if [ "$runtime" = "art" -a "$image_suffix" = "" ]; then |
Nicolas Geoffray | f654ef9 | 2017-06-09 16:31:21 +0100 | [diff] [blame] | 766 | # In no-prebuild or no-image mode, the compiler only quickens so disable the checker. |
| 767 | if [ "$prebuild_mode" = "yes" -a "$have_image" = "yes" ]; then |
David Brazdil | 80fb394 | 2015-07-23 11:53:42 +0100 | [diff] [blame] | 768 | run_checker="yes" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 769 | |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 770 | if [ "$target_mode" = "no" ]; then |
| 771 | cfg_output_dir="$tmp_dir" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 772 | checker_args="--arch=${host_arch_name^^}" |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 773 | else |
| 774 | cfg_output_dir="$DEX_LOCATION" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 775 | checker_args="--arch=${target_arch_name^^}" |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 776 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 777 | |
| 778 | if [ "$debuggable" = "yes" ]; then |
| 779 | checker_args="$checker_args --debuggable" |
| 780 | fi |
| 781 | |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 782 | run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \ |
David Brazdil | 80fb394 | 2015-07-23 11:53:42 +0100 | [diff] [blame] | 783 | -Xcompiler-option -j1" |
| 784 | fi |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 785 | fi |
| 786 | fi |
| 787 | |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 788 | run_args="${run_args} --testlib ${testlib}" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 789 | |
Richard Uhler | 020c0f3 | 2017-03-14 16:23:17 +0000 | [diff] [blame] | 790 | # To cause tests to fail fast, limit the file sizes created by dx, dex2oat and |
| 791 | # ART output to approximately 128MB. This should be more than sufficient |
| 792 | # for any test while still catching cases of runaway output. |
| 793 | # Set a hard limit to encourage ART developers to increase the ulimit here if |
| 794 | # needed to support a test case rather than resetting the limit in the run |
| 795 | # script for the particular test in question. |
Orion Hodson | bd328d3 | 2017-03-24 11:24:10 +0000 | [diff] [blame] | 796 | if ! ulimit -f 128000; then |
Richard Uhler | 020c0f3 | 2017-03-14 16:23:17 +0000 | [diff] [blame] | 797 | err_echo "ulimit file size setting failed" |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 798 | fi |
| 799 | |
Igor Murashkin | 2a33775 | 2017-06-16 14:34:40 +0000 | [diff] [blame] | 800 | if [[ "$target_mode" == "yes" ]]; then |
| 801 | build_args="$build_args --target" |
| 802 | else |
| 803 | build_args="$build_args --host" |
| 804 | fi |
| 805 | |
| 806 | if [[ "$dev_mode" == "yes" ]]; then |
| 807 | build_args="$build_args --dev" |
| 808 | fi |
| 809 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 810 | good="no" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 811 | good_build="yes" |
| 812 | good_run="yes" |
Alex Light | 77fee87 | 2017-09-05 14:51:49 -0700 | [diff] [blame^] | 813 | export TEST_RUNTIME="${runtime}" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 814 | if [ "$dev_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 815 | "./${build}" $build_args 2>&1 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 816 | build_exit="$?" |
| 817 | echo "build exit status: $build_exit" 1>&2 |
| 818 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 819 | echo "${test_dir}: running..." 1>&2 |
| 820 | "./${run}" $run_args "$@" 2>&1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 821 | run_exit="$?" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 822 | |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 823 | if [ "$run_exit" = "0" ]; then |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 824 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 825 | if [ "$target_mode" = "yes" ]; then |
| 826 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 827 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 828 | "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1 |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 829 | checker_exit="$?" |
| 830 | if [ "$checker_exit" = "0" ]; then |
| 831 | good="yes" |
| 832 | fi |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 833 | err_echo "checker exit status: $checker_exit" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 834 | else |
| 835 | good="yes" |
| 836 | fi |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 837 | fi |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 838 | echo "run exit status: $run_exit" 1>&2 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 839 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 840 | elif [ "$update_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 841 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 842 | build_exit="$?" |
| 843 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 844 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 845 | "./${run}" $run_args "$@" >"$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 846 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 847 | if [ "$target_mode" = "yes" ]; then |
| 848 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 849 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 850 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 851 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 852 | sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}" |
| 853 | good="yes" |
| 854 | else |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 855 | cat "$build_output" 1>&${real_stderr} 1>&2 |
| 856 | err_echo "build exit status: $build_exit" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 857 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 858 | elif [ "$build_only" = "yes" ]; then |
| 859 | good="yes" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 860 | "./${build}" $build_args >"$build_output" 2>&1 |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 861 | build_exit="$?" |
| 862 | if [ "$build_exit" '!=' '0' ]; then |
| 863 | cp "$build_output" "$output" |
| 864 | echo "build exit status: $build_exit" >>"$output" |
| 865 | diff --strip-trailing-cr -q "$expected" "$output" >/dev/null |
| 866 | if [ "$?" '!=' "0" ]; then |
| 867 | good="no" |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 868 | err_echo "BUILD FAILED For ${TEST_NAME}" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 869 | fi |
| 870 | fi |
Tsu Chiang Chuang | 379e2f5 | 2013-08-20 12:24:52 -0700 | [diff] [blame] | 871 | # Clean up extraneous files that are not used by tests. |
Tsu Chiang Chuang | 0160d99 | 2013-09-13 14:17:42 -0700 | [diff] [blame] | 872 | find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 873 | exit 0 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 874 | else |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 875 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 876 | build_exit="$?" |
| 877 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 878 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 879 | "./${run}" $run_args "$@" >"$output" 2>&1 |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 880 | run_exit="$?" |
| 881 | if [ "$run_exit" != "0" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 882 | err_echo "run exit status: $run_exit" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 883 | good_run="no" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 884 | elif [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 885 | if [ "$target_mode" = "yes" ]; then |
| 886 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 887 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 888 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 889 | checker_exit="$?" |
| 890 | if [ "$checker_exit" != "0" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 891 | err_echo "checker exit status: $checker_exit" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 892 | good_run="no" |
| 893 | else |
| 894 | good_run="yes" |
| 895 | fi |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 896 | else |
| 897 | good_run="yes" |
| 898 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 899 | else |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 900 | good_build="no" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 901 | cp "$build_output" "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 902 | echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output" |
| 903 | echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output" |
Ian Rogers | d9ad27d | 2014-10-27 13:48:21 -0700 | [diff] [blame] | 904 | echo "Args: ${args}" >> "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 905 | echo "build exit status: $build_exit" >> "$output" |
Andreas Gampe | 5c11490 | 2014-10-27 17:03:58 -0700 | [diff] [blame] | 906 | max_name_length=$(getconf NAME_MAX ${tmp_dir}) |
| 907 | echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output" |
| 908 | max_path_length=$(getconf PATH_MAX ${tmp_dir}) |
Andreas Gampe | 602fbcd | 2014-10-27 17:06:29 -0700 | [diff] [blame] | 909 | echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 910 | fi |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 911 | ./$check_cmd "$expected" "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 912 | if [ "$?" = "0" ]; then |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 913 | if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then |
| 914 | # output == expected |
| 915 | good="yes" |
| 916 | echo "${test_dir}: succeeded!" 1>&2 |
| 917 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 918 | fi |
| 919 | fi |
| 920 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 921 | ( |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 922 | if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 923 | echo "${test_dir}: FAILED!" |
| 924 | echo ' ' |
| 925 | echo '#################### info' |
| 926 | cat "${td_info}" | sed 's/^/# /g' |
| 927 | echo '#################### diffs' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 928 | diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 929 | echo '####################' |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 930 | if [ "$strace" = "yes" ]; then |
| 931 | echo '#################### strace output' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 932 | tail -n 3000 "$tmp_dir/$strace_output" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 933 | echo '####################' |
| 934 | fi |
Andreas Gampe | e79ca19 | 2017-07-31 10:30:16 -0700 | [diff] [blame] | 935 | if [ "x$target_mode" = "xno" -a "x$SANITIZE_HOST" = "xaddress" ]; then |
| 936 | # Run the stack script to symbolize any ASAN aborts on the host for SANITIZE_HOST. The |
| 937 | # tools used by the given ABI work for both x86 and x86-64. |
| 938 | echo "ABI: 'x86_64'" | cat - "$output" | $ANDROID_BUILD_TOP/development/scripts/stack | tail -n 3000 |
| 939 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 940 | echo ' ' |
| 941 | fi |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 942 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 943 | ) 2>&${real_stderr} 1>&2 |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 944 | |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 945 | # Attempt bisection only if the test failed. |
| 946 | if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then |
| 947 | # Bisecting works by skipping different optimization passes which breaks checker assertions. |
| 948 | if [ "$run_checker" == "yes" ]; then |
| 949 | echo "${test_dir}: not bisecting, checker test." 1>&2 |
| 950 | else |
| 951 | # Increase file size limit, bisection search can generate large logfiles. |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 952 | echo "${test_dir}: bisecting..." 1>&2 |
| 953 | cwd=`pwd` |
| 954 | maybe_device_mode="" |
| 955 | raw_cmd="" |
| 956 | if [ "$target_mode" = "yes" ]; then |
| 957 | # Produce cmdline.sh in $DEX_LOCATION. "$@" is passed as a runtime option |
| 958 | # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set |
| 959 | # to exec in order to preserve pid when calling dalvikvm. This is required |
| 960 | # for bisection search to correctly retrieve logs from device. |
| 961 | "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null |
| 962 | adb shell chmod u+x "$DEX_LOCATION/cmdline.sh" |
| 963 | maybe_device_mode="--device" |
| 964 | raw_cmd="$DEX_LOCATION/cmdline.sh" |
| 965 | else |
| 966 | raw_cmd="$cwd/${run} --external-log-tags $run_args $@" |
| 967 | fi |
| 968 | $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \ |
| 969 | $maybe_device_mode \ |
| 970 | --raw-cmd="$raw_cmd" \ |
| 971 | --check-script="$cwd/check" \ |
| 972 | --expected-output="$cwd/expected.txt" \ |
Wojciech Staszkiewicz | 0c88383 | 2016-09-26 17:51:52 -0700 | [diff] [blame] | 973 | --logfile="$cwd/bisection_log.txt" \ |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 974 | --timeout=300 |
| 975 | fi |
| 976 | fi |
| 977 | |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 978 | # Clean up test files. |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 979 | if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 980 | cd "$oldwd" |
| 981 | rm -rf "$tmp_dir" |
| 982 | if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then |
| 983 | adb shell rm -rf $DEX_LOCATION |
| 984 | fi |
| 985 | if [ "$good" = "yes" ]; then |
| 986 | exit 0 |
| 987 | fi |
| 988 | fi |
| 989 | |
| 990 | |
| 991 | ( |
| 992 | if [ "$always_clean" = "yes" ]; then |
| 993 | echo "${TEST_NAME} files deleted from host " |
| 994 | if [ "$target_mode" == "yes" ]; then |
| 995 | echo "and from target" |
| 996 | fi |
| 997 | else |
| 998 | echo "${TEST_NAME} files left in ${tmp_dir} on host" |
| 999 | if [ "$target_mode" == "yes" ]; then |
| 1000 | echo "and in ${DEX_LOCATION} on target" |
| 1001 | fi |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 1002 | fi |
| 1003 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 1004 | ) 2>&${real_stderr} 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1005 | |
Alex Light | 6a870fa | 2016-05-31 16:36:19 -0700 | [diff] [blame] | 1006 | if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then |
| 1007 | exit 0 |
| 1008 | else |
| 1009 | exit 1 |
| 1010 | fi |